xfs: convert tests to SPDX license tags
[xfstests-dev.git] / tests / xfs / 030
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 030
6 #
7 # exercise xfs_repair repairing broken filesystems
8 #
9 seqfull=$0
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17
18 _cleanup()
19 {
20         cd /
21         _scratch_unmount 2>/dev/null
22         rm -f $tmp.*
23 }
24
25 trap "_cleanup; exit \$status" 0 1 2 3 15
26
27 # get standard environment, filters and checks
28 . ./common/rc
29 . ./common/filter
30 . ./common/repair
31
32 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
33 #
34 _check_ag()
35 {
36         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
37         do
38                 echo "Corrupting $structure - setting bits to $1"
39                 _check_repair $1 "$structure" | uniq |
40                         sed -e '/^error following ag 0 unlinked list$/d' \
41                             -e '/^bad agbno AGBNO for finobt/d' \
42                             -e '/^bad agbno AGBNO for rmapbt/d' \
43                             -e '/^bad agbno AGBNO for refcntbt/d' \
44                             -e '/^Missing reverse-mapping record.*/d' \
45                             -e '/^unknown block state, ag AGNO, block.*/d'
46         done
47 }
48
49 # real QA test starts here
50 _supported_fs xfs
51 _supported_os Linux
52
53 _require_scratch
54 _require_no_large_scratch_dev
55
56 DSIZE="-dsize=100m,agcount=6"
57
58 # first we need to ensure there are no bogus secondary
59 # superblocks between the primary and first secondary
60 # superblock (hanging around from earlier tests)...
61 #
62
63 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
64 if [ $? -ne 0 ]         # probably don't have a big enough scratch
65 then
66         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
67 else
68         _scratch_mount
69         src/feature -U $SCRATCH_DEV && \
70                 _notrun "UQuota are enabled, test needs controlled sb recovery"
71         src/feature -G $SCRATCH_DEV && \
72                 _notrun "GQuota are enabled, test needs controlled sb recovery"
73         src/feature -P $SCRATCH_DEV && \
74                 _notrun "PQuota are enabled, test needs controlled sb recovery"
75         _scratch_unmount
76 fi
77 clear=""
78 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | perl -ne '
79         if (/byte offset (\d+), length (\d+)/) {
80                 print "clear=", $1 / 512, "\n"; exit
81         }'`
82 [ -z "$clear" ] && echo "Cannot calculate length to clear"
83 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
84
85 # now kick off the real repair test...
86 #
87 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
88 . $tmp.mkfs
89 _check_ag 0
90 _check_ag -1
91
92 # success, all done
93 status=0
94 exit